
void drawFront();
void drawBack();
void drawsilhouetteBackFattened();
void drawFrontSharp(GLfloat tt, GLfloat ttt[3], GLfloat t, GLfloat factor);
void drawValley();
void drawValley2();
void drawBackFattened();
void drawObject();


GLfloat sharpThreshold = 45.0*3.1415928/180.0;
int sharpFlag = 0;
GLfloat offset_factor = 0.0, offset_units = 0.1;


// draw Silhouettes (2001 paper)
void drawBackFattened()
{
	int i,j,num;

	GLfloat eyeVec[3];
	GLfloat eyeT[3];
	GLfloat eyeDist, orntFactor, cosAngle, cosAlpha,k,k2,kShift = 0.3;
	GLfloat modelview_mat[16], iview[16], id_mat[16];

	GLfloat vert01[3], vert10[3];
	GLfloat temp[3];
	GLfloat temp1[3];
	Vec3 Edge[3], edgeN[3];

	glGetFloatv(GL_MODELVIEW_MATRIX, modelview_mat);
	mat4Invert(modelview_mat, iview);
	mat4Mult(modelview_mat, iview, id_mat);
	
	mat4vec3Mult(iview, eye, eyeT);

	num = CURRENT_MODEL;
	glBegin(GL_QUADS);
	for (i = 0; i < trisStruct[num].numTris; i ++) {

		vecSub( eyeT,trisStruct[num].tris[i].midpt, eyeVec);
		eyeDist = vecMagn(eyeVec);
		vecNormalize(eyeVec);
		cosAngle = vecDotProduct(eyeVec,trisStruct[num].tris[i].norm);
		if (cosAngle <  cosAngleThreshold) /* back face culling */{
			if (cosAngle < 0) cosAngle = - cosAngle;
			orntFactor = (eyeDist/10.0)/(cosAngle + kShift);  // z / (V.N)
			k = orntFactor*scaleT;

			for (j = 0; j < 3; j++) {
				vecSub(vertStruct[num].verts[trisStruct[num].tris[i].vert[(j+1)%3]].d,
					vertStruct[num].verts[trisStruct[num].tris[i].vert[j]].d, Edge[j]);
				vecNormalize(Edge[j]);
				vecCross(Edge[j], trisStruct[num].tris[i].norm, edgeN[j]);
				vecNormalize(edgeN[j]);
			}

			/* push all three edges out along the edge-normals */
			for (j = 0; j < 3; j++) {
				cosAlpha = vecDotProduct(eyeVec,Edge[j]);
				k2 = sqrt(1.0 - cosAlpha*cosAlpha);  // sinAlpha
				vecScale(edgeN[j], k*k2,temp1);
				vecScale(edgeN[j], k*k2,temp1);
				vecAdd(vertStruct[num].verts[trisStruct[num].tris[i].vert[j]].d,temp1, vert01);
				vecAdd(vertStruct[num].verts[trisStruct[num].tris[i].vert[(j+1)%3]].d,temp1, vert10);
				// Draw QUAD with two triangles maybe
				glVertex3fv(vertStruct[num].verts[trisStruct[num].tris[i].vert[j]].d);
				glVertex3fv(vert01);
				glVertex3fv(vert10);
				glVertex3fv(vertStruct[num].verts[trisStruct[num].tris[i].vert[(j+1)%3]].d);
			}

						/* connect the fan *//*
            glVertex3fv(vert10);			glVertex3fv(vert12);			glVertex3fv(trisStruct[num].tris[i].midpt);
			
			glVertex3fv(vert21);			glVertex3fv(vert20);			glVertex3fv(trisStruct[num].tris[i].midpt);
			
			glVertex3fv(vert02);			glVertex3fv(vert01);			glVertex3fv(trisStruct[num].tris[i].midpt);*/

		}
	}
    glEnd();
}

// draw extra quad at 'sharpThreshold' angle to support convex or concave sharp creases (2001 paper)

void drawFrontSharp(GLfloat sharpThresholdLocal, GLfloat colorLocal[], GLfloat lineWidthLocal, GLfloat factor)
{
	int i,j,num;

	GLfloat eyeVec[3];
	GLfloat eyeT[3];
	GLfloat eyeDist, orntFactor, cosAngle, cosAlpha,k,k2,kShift = 0.1;
	GLfloat modelview_mat[16], iview[16];

	GLfloat vert01[3], vert10[3];
	GLfloat temp[3];
	GLfloat temp1[3];
	Vec3 Edge[3], edgeN[3], Ncos, edgeNsin[3], edgeShift;

	glDisable(GL_BLEND);
	glGetFloatv(GL_MODELVIEW_MATRIX, modelview_mat);
	mat4Invert(modelview_mat, iview);
	mat4vec3Mult(iview, eye, eyeT);

	num = CURRENT_MODEL;

	glDisable(GL_CULL_FACE);

	glColor3f(1.0,1.0,0.0);
	glBegin(GL_TRIANGLES);
	for (i = 0; i < trisStruct[num].numTris; i ++) {
		//if (num == BUNNY_MODEL) glColor3fv(trisStruct[num].tris[i].color);
		glVertex3fv(vertStruct[num].verts[trisStruct[num].tris[i].vert[0]].d);
		glVertex3fv(vertStruct[num].verts[trisStruct[num].tris[i].vert[1]].d);
		glVertex3fv(vertStruct[num].verts[trisStruct[num].tris[i].vert[2]].d);
	}
	glEnd();
 
	//draw the creases
	
	glDepthFunc(GL_LEQUAL);
	glColor3fv(colorLocal);

	GLfloat cosThr = -factor*lineWidthLocal*cos(sharpThresholdLocal); // negative normal
	GLfloat sinThr = lineWidthLocal*sin(sharpThresholdLocal);


	glBegin(GL_QUADS);
	for (i = 0; i < trisStruct[num].numTris; i ++) {

		vecSub( eyeT,trisStruct[num].tris[i].midpt, eyeVec);
		eyeDist = vecMagn(eyeVec);
		vecNormalize(eyeVec);
		cosAngle = vecDotProduct(eyeVec,trisStruct[num].tris[i].norm);

		if (cosAngle <=0) continue; // remove backfacing

		{
			if (cosAngle < 0) cosAngle = - cosAngle;
			//orntFactor = (eyeDist/10.0)/(cosAngle + kShift);  // z / (V.N)
			orntFactor = (eyeDist/10.0)*(sqrt(1.0 - cosAngle*cosAngle) + kShift);
			k = orntFactor*scaleT;

			for (j = 0; j < 3; j++) {
				vecSub(vertStruct[num].verts[trisStruct[num].tris[i].vert[(j+1)%3]].d,
					vertStruct[num].verts[trisStruct[num].tris[i].vert[j]].d, Edge[j]);
				vecNormalize(Edge[j]);
				vecCross(Edge[j], trisStruct[num].tris[i].norm, edgeN[j]);
				vecNormalize(edgeN[j]);
			}

			/* push all three edges out along the edge-normals */
			for (j = 0; j < 3; j++) {
				//cosAlpha = vecDotProduct(eyeVec,Edge[j]);
				//k2 = sqrt(1.0 - cosAlpha*cosAlpha);  // sinAlpha

				vecScale(trisStruct[num].tris[i].norm,cosThr,Ncos);
				vecScale(edgeN[j], sinThr, edgeNsin[j]);
				vecAdd(Ncos,edgeNsin[j],edgeShift);
				vecAdd(vertStruct[num].verts[trisStruct[num].tris[i].vert[j]].d, edgeShift, vert01);
				vecAdd(vertStruct[num].verts[trisStruct[num].tris[i].vert[(j+1)%3]].d, edgeShift, vert10);
				// Draw QUAD with two triangles maybe
				glVertex3fv(vertStruct[num].verts[trisStruct[num].tris[i].vert[j]].d);
				glVertex3fv(vert01);
				glVertex3fv(vert10);
				glVertex3fv(vertStruct[num].verts[trisStruct[num].tris[i].vert[(j+1)%3]].d);
			}
		}
	}
    glEnd();
	glEnable(GL_BLEND);

}

// draw ridges convex sharp creases (2001 paper)
void
drawSharps()
{
	GLfloat sharpColor[3] = {0.2,0.2,0.2};
  if (colorObjFlag == 0) glColorMask(GL_FALSE, GL_FALSE, GL_FALSE, GL_FALSE);
  glCullFace(GL_BACK);
  glEnable(GL_CULL_FACE);
  glDepthMask(GL_TRUE);  
  glColor4f(0.8f, 0.8f, 1.f, 1.0f); 
  drawFrontSharp(sharpThreshold, sharpColor, lineWidth, 1.0);
  if(glGetError())
    printf("oops! Bad gl command after curobjSimple!\n");
  
  glColorMask(GL_TRUE, GL_TRUE, GL_TRUE, GL_TRUE);
  glPolygonMode(GL_BACK, GL_FILL);
  glDepthFunc(GL_LEQUAL);
  glDisable(GL_CULL_FACE);
  if (colorObjFlag == 0) glColor3f(0.5f, 0.f, 0.f); else glColor4f(0.f, 0.f, 0.f, 1.0f);
}


// draw valleys concave sharp creases (2001 paper)
// paper suggests using a second depth buffer for single pass rendering
// here we use a stencil buffer with four pass rendering to demonstrate the concept

void drawValley2()
{
/*	Render everything or render front, update depth buffer
	Render extra stuff from front face, set stencil where z-passes
	Render back
	Render extra stuff from front face, where stencil not set
	*/

	GLfloat sharpColor[3] = {0.0,0.1,0.2};

	// Step 1
    // glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
    glStencilFunc (GL_ALWAYS, 0x1, 0x1);
    glStencilOp (GL_KEEP, GL_KEEP, GL_KEEP);
	glColor3f(1.0,1.0,0.0);
	glEnable(GL_CULL_FACE);
    glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
    gluPerspective(FOV, (float) winWidth/winHeight,1.0,ZFAR);
    glMatrixMode(GL_MODELVIEW);
	if (sharpFlag) { drawsilhouetteBackFattened(); drawSharps();} else drawFront();
	glDisable(GL_CULL_FACE);
	glColorMask(GL_FALSE, GL_FALSE, GL_FALSE, GL_FALSE);

	// Step 2
    glClearStencil(0x1);
    glEnable(GL_STENCIL_TEST);

    glStencilFunc (GL_ALWAYS, 0x1, 0xFF);
    glStencilOp (GL_KEEP, GL_KEEP, GL_INCR);

	glColor3f(1.0,0,0);
	glDepthMask(GL_FALSE);
	glEnable(GL_CULL_FACE);
	//drawExtraStuff(1.0);
	drawFrontSharp(sharpThreshold, sharpColor, lineWidth, -1.0);

	glDisable(GL_CULL_FACE);
	glDepthMask(GL_TRUE);
	
	// Step 3
    glClear(GL_DEPTH_BUFFER_BIT);
    glStencilOp (GL_KEEP, GL_KEEP, GL_KEEP);
    glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
//	glTranslatef(0,0,0.0001);
	glTranslatef(0,0,offset_units*0.0001);
    gluPerspective(FOV, (float) winWidth/winHeight,1.0,ZFAR);
	//glTranslatef(0,0,offset_units);
    glMatrixMode(GL_MODELVIEW);
	 drawFront();
    glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
    gluPerspective(FOV, (float) winWidth/winHeight,1.0,ZFAR);
    glMatrixMode(GL_MODELVIEW);
	glDisable(GL_CULL_FACE);
	// drawBackFattened;
	// drawBackSimple();
	// drawBack();

//    glClear(GL_COLOR_BUFFER_BIT); 
	// Step 4
	glDepthFunc(GL_LESS);
    glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
    gluPerspective(FOV, (float) winWidth/winHeight,1.0,ZFAR);
    glMatrixMode(GL_MODELVIEW);
    glStencilFunc (GL_ALWAYS, 0x1, 0xFF);
    glStencilOp (GL_KEEP, GL_KEEP, GL_DECR);
	glDepthMask(GL_FALSE);
	glEnable(GL_CULL_FACE);
	//drawExtraStuff(1.0);
	drawFrontSharp(sharpThreshold, sharpColor, lineWidth, -1.0);
	glDisable(GL_CULL_FACE);
	glColorMask(GL_TRUE, GL_TRUE, GL_TRUE, GL_TRUE);
    glStencilFunc (GL_EQUAL, 0x0, 0xFF);
    glStencilOp (GL_KEEP, GL_KEEP, GL_KEEP);
	glEnable(GL_CULL_FACE);
	//drawExtraStuff(1.0);
	glColor3f(0.0,0,0.2);
	drawFront();
	glDisable(GL_CULL_FACE);
    glClear(GL_STENCIL_BUFFER_BIT); 
	glDepthMask(GL_TRUE);
    glDisable(GL_STENCIL_TEST);
	glDepthFunc(GL_LEQUAL);

}

// draw intersections (2001 paper)
// paper suggests using a second depth buffer for single pass rendering
// here we use a stencil buffer with three pass rendering to demonstrate the concept


void drawIntersect()
{
/*  Render front polys shifted back
    Render front, incrementing when z passes
	Wherever stencil = 2, is the intersection, just draw big rect
*/
	static int shiftCount = 100;

    // glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
    glStencilFunc (GL_ALWAYS, 0x1, 0x1);
    glStencilOp (GL_KEEP, GL_KEEP, GL_KEEP);
    glDisable(GL_STENCIL_TEST);
	glEnable(GL_CULL_FACE);
    glEnable(GL_DEPTH_TEST);
	glDepthFunc(GL_LEQUAL);
	glDepthMask(GL_TRUE);
	glColor3f(1.0,0.0,0.0);
    glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glTranslatef(0,0,offset_units*0.0001);
    gluPerspective(FOV, (float) winWidth/winHeight,1.0,ZFAR);
    glMatrixMode(GL_MODELVIEW);
	drawFront(); glPushMatrix(); glTranslatef(shiftCount, 20+shiftCount/5.0 , 0); glRotatef(50,1,0,0); drawFront(); glPopMatrix();
	//drawSharps(); glPushMatrix(); glTranslatef(shiftCount, shiftCount/5.0 , 0); drawSharps(); glPopMatrix();
	//drawsilhouetteBackFattened(); glPushMatrix(); glTranslatef(shiftCount, shiftCount/5.0 , 0); drawsilhouetteBackFattened(); glPopMatrix();

    glClearStencil(0x0);
    glClear(GL_STENCIL_BUFFER_BIT); 
    glEnable(GL_STENCIL_TEST);
    glStencilFunc (GL_ALWAYS, 0x1, 0xFF);
    glStencilOp (GL_KEEP, GL_KEEP, GL_INCR);
	glDepthMask(GL_FALSE);
	glColor3f(1.0,1.0,0.0);
    glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
    gluPerspective(FOV, (float) winWidth/winHeight,1.0,ZFAR);
    glMatrixMode(GL_MODELVIEW);
	//drawFront();
	//drawFront(); glPushMatrix(); glTranslatef(shiftCount, 20+shiftCount/5.0 , 0); drawFront(); glPopMatrix();
	//drawSharps(); glPushMatrix(); glTranslatef(shiftCount, 20+shiftCount/5.0, 0); drawSharps(); glPopMatrix();
	drawsilhouetteBackFattened(); glPushMatrix(); glTranslatef(shiftCount, 20+shiftCount/5.0 , 0); glRotatef(50,1,0,0); drawsilhouetteBackFattened(); glPopMatrix();
	glDepthMask(GL_TRUE);

    glStencilFunc (GL_EQUAL, 2, 0xFF);
    //glStencilFunc (GL_ALWAYS, 0x1, 0xFF);
    glStencilOp (GL_KEEP, GL_KEEP, GL_KEEP);
	glColor3f(0.0,0.0,1.0);
    glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glTranslatef(0,0,-offset_units*0.0001);
    gluPerspective(FOV, (float) winWidth/winHeight,1.0,ZFAR);
    glMatrixMode(GL_MODELVIEW);
	//drawFront();
	drawFront(); glPushMatrix(); glTranslatef(shiftCount, 20+shiftCount/5.0 , 0); glRotatef(50,1,0,0); /*drawFront();*/ glPopMatrix();
	//drawSharps(); glPushMatrix(); glTranslatef(shiftCount, 20+shiftCount/5.0, 0); drawSharps(); glPopMatrix();
	//drawsilhouetteBackFattened(); glPushMatrix(); glTranslatef(shiftCount, shiftCount/5.0 , 0); drawsilhouetteBackFattened(); glPopMatrix();
	shiftCount-= 1; if (shiftCount == -100) shiftCount = 100;

    glDisable(GL_STENCIL_TEST);
}


// draw intersections and valleys together (2001 paper)
// paper suggests using a second depth buffer for single pass rendering
// here we use a stencil buffer with four pass rendering to demonstrate the concept

void drawValleyIntersect()
{
/*	Render everything or render front, update depth buffer
	Render extra stuff from front face, set stencil where z-passes
	Render back
	Render extra stuff from front face, where stencil not set
	*/

	GLfloat sharpColor[3] = {0.0,0.1,0.2};

	// Step 1
    // glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
    glStencilFunc (GL_ALWAYS, 0x1, 0x1);
    glStencilOp (GL_KEEP, GL_KEEP, GL_KEEP);
	glColor3f(1.0,1.0,0.0);
	glEnable(GL_CULL_FACE);
    glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
    gluPerspective(FOV, (float) winWidth/winHeight,1.0,ZFAR);
    glMatrixMode(GL_MODELVIEW);
	if (sharpFlag) drawSharps(); else drawFront();
	glDisable(GL_CULL_FACE);
	glColorMask(GL_FALSE, GL_FALSE, GL_FALSE, GL_FALSE);

	// Step 2
    glClearStencil(2);
    glEnable(GL_STENCIL_TEST);

    glStencilFunc (GL_ALWAYS, 0x1, 0xFF);
    glStencilOp (GL_KEEP, GL_KEEP, GL_INCR);

	glColor3f(1.0,0,0);
	glDepthMask(GL_FALSE);
	glEnable(GL_CULL_FACE);
	//drawExtraStuff(1.0);
	drawFrontSharp(sharpThreshold, sharpColor, lineWidth, -1.0);
	glDisable(GL_CULL_FACE);
	glDepthMask(GL_TRUE);
	
	// Step 3
    glClear(GL_DEPTH_BUFFER_BIT);
    glStencilOp (GL_KEEP, GL_KEEP, GL_KEEP);
    glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
//	glTranslatef(0,0,0.0001);
	glTranslatef(0,0,offset_units*0.0001);
    gluPerspective(FOV, (float) winWidth/winHeight,1.0,ZFAR);
	//glTranslatef(0,0,offset_units);
    glMatrixMode(GL_MODELVIEW);
	 drawFront();
    glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
    gluPerspective( FOV, (float) winWidth/winHeight, 1.0,ZFAR);
    glMatrixMode(GL_MODELVIEW);
	glDisable(GL_CULL_FACE);
	// drawBackFattened;
	// drawBackSimple();
	// drawBack();

//    glClear(GL_COLOR_BUFFER_BIT); 
	// Step 4
	glDepthFunc(GL_LESS);
    glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
    gluPerspective( FOV, (float) winWidth/winHeight, 1.0,ZFAR);
    glMatrixMode(GL_MODELVIEW);
    glStencilFunc (GL_ALWAYS, 0x1, 0xFF);
    glStencilOp (GL_KEEP, GL_KEEP, GL_DECR);
	glDepthMask(GL_FALSE);
	glEnable(GL_CULL_FACE);
	drawFront();
	//drawExtraStuff(1.0);
	drawFrontSharp(sharpThreshold, sharpColor, lineWidth, -1.0);
	glDisable(GL_CULL_FACE);
	glColorMask(GL_TRUE, GL_TRUE, GL_TRUE, GL_TRUE);
    glStencilFunc (GL_EQUAL, 0x0, 0xFF);
    glStencilOp (GL_KEEP, GL_KEEP, GL_KEEP);
	glEnable(GL_CULL_FACE);
	glColor3f(0.0,0,0);
	drawFront();
	glDisable(GL_CULL_FACE);
    glClear(GL_STENCIL_BUFFER_BIT); 
	glDepthMask(GL_TRUE);
    glDisable(GL_STENCIL_TEST);
	glDepthFunc(GL_LEQUAL);
}

